# When running on docker, run `docker run --rm --privileged multiarch/qemu-user-static --reset -p yes` to enable emulation

apt update
apt install -y wget xz-utils git curl unzip

# FLUTTER_VERSION="3.27.1"
# FLUTTER_DOWNLOAD_FILE="flutter.zip"
# wget https://storage.googleapis.com/flutter_infra_release/releases/stable/linux/flutter_linux_${FLUTTER_VERSION}-stable.tar.xz -O ${FLUTTER_DOWNLOAD_FILE}
# mkdir -p /flutter
# tar -xf ${FLUTTER_DOWNLOAD_FILE} --strip-components=1 --directory /flutter

FLUTTER_DIR=/opt/flutter
FLUTTER_VERSION=3.27.1
git clone --depth 1 https://github.com/flutter/flutter.git ${FLUTTER_DIR}
cd ${FLUTTER_DIR}
git fetch origin tag ${FLUTTER_VERSION}
git checkout tags/${FLUTTER_VERSION}
PATH="${PATH}:${FLUTTER_DIR}/bin"
cd /

flutter precache --universal

# # Test android
apt install -y openjdk-17-jdk

export ANDROID_HOME="/opt/android"
CMDLINETOOLS_DIR="$ANDROID_HOME/cmdline-tools/latest"
CMDLINETOOLS_VERSION="11076708"
CMDLINETOOLS_ZIP="/tmp/cmdline-tools.zip"
wget "https://dl.google.com/android/repository/commandlinetools-linux-${CMDLINETOOLS_VERSION}_latest.zip" -O $CMDLINETOOLS_ZIP
unzip -q $CMDLINETOOLS_ZIP -d /tmp
mkdir -p ${CMDLINETOOLS_DIR}
mv /tmp/cmdline-tools/* $CMDLINETOOLS_DIR
PATH="${PATH}:${ANDROID_HOME}/cmdline-tools/latest/bin:${ANDROID_HOME}/platform-tools"
yes | sdkmanager --sdk_root=${ANDROID_HOME} --licenses
yes "y" | flutter doctor --android-licenses

flutter precache --universal --android
flutter config --local-engine-src-path /out/engine/src/ --local-engine /out/engine/src/out/android_debug_unopt_arm64/ --local-engine-host /out/engine/src/out/host_debug_unopt/
flutter config --enable-android
flutter create --project-name android_test -t app --platforms android android_test
cd android_test/android
./gradlew wrapper --gradle-version=8.1
cd ..
flutter pub get
flutter build appbundle --debug --target-platform android-arm64
# # flutter build appbundle --profile --target-platform android-arm,android-arm64,android-x64
# # flutter build appbundle --release --target-platform android-arm,android-arm64,android-x64
# cd ..
